<?php
/**
 * @version		1.2.0
 * @package		Joomla
 * @subpackage	Helpdesk Pro
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * HTML View class for Helpdesk Pro component
 *
 * @static
 * @package		Joomla
 * @subpackage	Helpdesk Pro
 * @since 1.5
 */
class HelpdeskproViewTicket extends JViewLegacy
{

	function display($tpl = null)
	{
		$layout = $this->getLayout();
		if ($layout == 'form')
		{
			$this->_displayForm($tpl);
			return;
		}
		$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$item = $this->get('Data');
		if (!$item->id)
		{
			$app = JFactory::getApplication();
			$app->redirect('index.php', JText::_('HDP_INVALID_TICKET'));
		}				
		$canAccess = HelpdeskProHelper::checkTicketAccess($item);
		if (!$canAccess)
		{
			if (!$user->id && !$item->is_ticket_code)
			{
				$app = JFactory::getApplication();
				$return = JRoute::_('index.php?option=com_helpdeskpro&view=ticket&id=' . $item->id . '&Itemid=' . JRequest::getInt('Itemid'));
				$return = base64_encode($return);
				$app->redirect('index.php?option=com_users&view=login&return=' . $return, JText::_('HDP_PLEASE_LOGIN_TO_CONTINUE'));
			}
		}
		$config = HelpdeskProHelper::getConfig();
		$sql = 'SELECT a.*, b.name FROM #__helpdeskpro_messages AS a LEFT JOIN #__users AS b ON a.user_id=b.id WHERE ticket_id=' . $item->id .
			 ' ORDER BY a.id DESC';
		$db->setQuery($sql);
		$messages = $db->loadObjectList();						
		$sql = "SELECT id, parent_id, title FROM #__helpdeskpro_categories WHERE published=1"
			." AND access IN (" . implode(',', $user->getAuthorisedViewLevels()) . ')'
			." ORDER BY ordering "				 			 
		;
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		
		for ($i = 0, $n = count($rows) ; $i < $n; $i++)
		{
			$row = $rows[$i];
			$row->title = JText::_($row->title);
		}
		
		$children = array();
		if ($rows)
		{
			// first pass - collect children
			foreach ($rows as $v)
			{
				$pt = $v->parent_id;
				$list = @$children[$pt] ? $children[$pt] : array();
				array_push($list, $v);
				$children[$pt] = $list;
			}
		}
		$categories = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0);
		
		//Get all custom fields
		$sql = 'SELECT * FROM #__helpdeskpro_fields WHERE published=1 AND (category_id = -1 OR id IN (SELECT field_id FROM #__helpdeskpro_field_categories WHERE category_id=' .
			 $item->category_id . ')) ORDER BY ordering ';
		$db->setQuery($sql);
		$fields = $db->loadObjectList();
		
		$sql = 'SELECT title FROM #__helpdeskpro_statuses WHERE id=' . $item->status_id;
		$db->setQuery($sql);
		$item->status = $db->loadResult();
		
		$sql = 'SELECT title FROM #__helpdeskpro_priorities WHERE id=' . $item->priority_id;
		$db->setQuery($sql);
		$item->priority = $db->loadResult();
		//Get all custom fields value belong to this support ticket
		

		$sql = 'SELECT field_id, field_value FROM #__helpdeskpro_field_value WHERE ticket_id=' . $item->id;
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$fieldValues = array();
		if (count($rows))
		{
			foreach ($rows as $row)
			{
				$fieldValues[$row->field_id] = $row->field_value;
			}
		}
		
		$sql = 'SELECT id, title FROM #__helpdeskpro_statuses WHERE published=1 ORDER BY ordering';
		$db->setQuery($sql);
		$rowStatuses = $db->loadObjectList();
		
		for ($i = 0, $n = count($rowStatuses) ; $i < $n; $i++)
		{
			$rowStatus = $rowStatuses[$i];
			$rowStatus->title = JText::_($rowStatus->title);
		}
		
		$sql = 'SELECT id, title FROM #__helpdeskpro_priorities WHERE published=1 ORDER BY ordering';
		$db->setQuery($sql);
		$rowPriorities = $db->loadObjectList();
		
		for ($i = 0, $n = count($rowPriorities) ; $i < $n; $i++)
		{
			$rowPriority = $rowPriorities[$i];
			$rowPriority->title = JText::_($rowPriority->title);
		}
		
		$dateFormat = HelpdeskProHelper::getConfigValue('date_format');
		
		if ($user->id == $item->user_id || $item->is_ticket_code)
			$isCustomer = 1;
		else
			$isCustomer = 0;
		
		if ($isCustomer && ($item->status_id == $config->closed_ticket_status))
		{
			$canComment = false;
		}
		else
		{
			$canComment = true;
		}
		$Itemid = JRequest::getInt('Itemid');
		$message = JRequest::getVar('message', '', 'post', JREQUEST_ALLOWHTML);
		$captchaInvalid = JRequest::getInt('captcha_invalid', 0);		
		if ($config->highlight_code) {
			HelpdeskProHelper::loadHighlighter();
		}		
		$this->fields = $fields;
		$this->messages = $messages;
		$this->fieldValues = $fieldValues;
		$this->rowStatuses = $rowStatuses;
		$this->rowPriorities = $rowPriorities;
		$this->categories = $categories;
		$this->dateFormat = $dateFormat;
		$this->config = $config;
		$this->item = $item;
		$this->isCustomer = $isCustomer;
		$this->canComment = $canComment;
		$this->Itemid = $Itemid;
		$this->message = $message;
		$this->captchaInvalid = $captchaInvalid;
		
		parent::display($tpl);
	}

	function _displayForm($tpl)
	{
		$db = JFactory::getDbo();
		$user = JFactory::getUser();
		$config = HelpdeskProHelper::getConfig();
		$userId = $user->get('id');
		$Itemid = JRequest::getInt('Itemid', 0);
		$captchaInvalid = JRequest::getInt('captcha_invalid', 0);
		$name = JRequest::getVar('name', '', 'post');
		$email = JRequest::getVar('email', '', 'post');
		$subject = JRequest::getVar('subject', '', 'post');
		$message = JRequest::getVar('message', '', 'post', JREQUEST_ALLOWHTML);
		$categoryId = JRequest::getInt('category_id', 0);
		$priorityId = JRequest::getInt('priority_id', 0);
		if (!$userId && !$config->allow_public_user_submit_ticket)
		{
			//Redirect user to login page
			$return = JRoute::_('index.php?option=com_helpdeskpro&task=ticket.add&Itemid=' . $Itemid);
			JFactory::getApplication()->redirect('index.php?option=com_users&view=login&return=' . base64_encode($return), 
				JText::_('HDP_LOGIN_TO_SUBMIT_TICKET'));
		}
		$sql = "SELECT id, parent_id, title FROM #__helpdeskpro_categories WHERE published=1"
			." AND access IN (" . implode(',', $user->getAuthorisedViewLevels()) . ')'
			." ORDER BY ordering"				 			 
		;
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		for ($i = 0, $n = count($rows) ; $i < $n; $i++)
		{
			$row = $rows[$i];
			$row->title = JText::_($row->title);
		}
		$children = array();
		if ($rows)
		{
			// first pass - collect children
			foreach ($rows as $v)
			{
				$pt = $v->parent_id;
				$list = @$children[$pt] ? $children[$pt] : array();
				array_push($list, $v);
				$children[$pt] = $list;
			}
		}
		$list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0);
		$options = array();
		$options[] = JHtml::_('select.option', 0, JText::_('HDP_CHOOSE_CATEGORY'));
		foreach ($list as $listItem)
		{
			$options[] = JHTML::_('select.option', $listItem->id, '&nbsp;&nbsp;&nbsp;' . $listItem->treename);
		}
		
		$lists['category_id'] = JHTML::_('select.genericlist', $options, 'category_id', 
			array(
				'option.text.toHtml' => false, 
				'option.text' => 'text', 
				'option.value' => 'value', 
				'list.attr' => 'class="inputbox" onchange="showFields(this.form);" ', 
				'list.select' => $categoryId));
		
		$options = array();
		$options[] = JHtml::_('select.option', 0, JText::_('HDP_CHOOSE_PRIORITY'), 'id', 'title');
		$sql = 'SELECT id, title FROM #__helpdeskpro_priorities WHERE published=1 ORDER BY ordering';
		$db->setQuery($sql);
		$rowPriorities = $db->loadObjectList();
		
		for($i = 0, $n = count($rowPriorities) ; $i < $n; $i++)
		{
			$rowPriority = $rowPriorities[$i];
			$rowPriority->title = JText::_($rowPriority->title);
		}
		
		$options = array_merge($options, $rowPriorities);
		
		$lists['priority_id'] = JHTML::_('select.genericlist', $options, 'priority_id', 
			array(
				'option.text.toHtml' => false, 
				'option.text' => 'title', 
				'option.key' => 'id', 
				'list.attr' => 'class="inputbox" ', 
				'list.select' => $priorityId > 0 ? $priorityId : $config->default_ticket_priority_id));
		$jcFields = new JCFields();
		if ($jcFields->getTotal())
		{
			$customField = true;
			$fieldArray = JCFields::getAssoc();
			$fieldJs = "fields = new Array();\n";
			foreach ($fieldArray as $catId => $fieldList)
			{
				$fieldJs .= ' fields[' . $catId . '] = new Array("' . implode('","', $fieldList) . '");' . "\n";
			}
			$this->assign('fieldJs', $fieldJs);
			$fields = $jcFields->renderCustomFields($categoryId, $fieldArray);
			$validations = $jcFields->renderJSValidation();
			$this->assign('fields', $fields);
			$this->assign('validations', $validations);
		}
		else
		{
			$customField = false;
		}
		$this->assign('customField', $customField);
		
		$this->lists = $lists;
		$this->Itemid = $Itemid;
		$this->config = $config;
		$this->userId = $userId;
		$this->captchaInvalid = $captchaInvalid;
		$this->name = $name;
		$this->email = $email;
		$this->subject = $subject;
		$this->message = $message;
		
		parent::display($tpl);
	}
}